package pkg.crawler.main;

import pkg.crawler.data.conn.Crawler;

public class Main {

	/**
	 * @param args
	 * Deverão ser 4 argumentos: 
	 */
	public static void main(String[] args) {
		
		if (args == null || args.length != 4){
			System.out.println("Uso:\n" +
					"java -jar crawler.jar [imap_host] [imap_admin_password] " +
					"[http_solr_host_address] [login_starts_with]\n" +
					"imap_host - O endereço que está instalado o Expresso Ex: \"127.1.1.1\"\n" +
					"imap_admin_password - Senha do usuário 'expresso-admin' Ex: \"admin123\"\n" +
					"http_solr_host_address - Endereço do servidor do Solr Ex: \"http://127.1.1.1:8983/solr/\"\n" +
					"login_starts_with - Caracteres que esse crawler deverá verificar Ex: \"abcde\"");
			System.exit(0);
		}
		
		//O endereço que está instalado o Expresso Ex: "127.1.1.1"
		String host = args[0];
		//Senha do usuário 'expresso-admin' Ex: "admin123"
		String password = args[1];
		//Endereço do servidor do Solr Ex: "http://127.1.1.1:8983/solr/"
		String hostSolr = args[2];
		//Caracteres que esse crawler deverá verificar Ex: "abcde"
		String loginStartsWith = args[3];
		
		//Para cada letra definida contida na variável "loginStartsWith" iniciará uma thread do crawler
		for ( int i = 0; i < loginStartsWith.length(); i++)
		{
			Crawler crawler = new Crawler(host, password, hostSolr, String.valueOf(loginStartsWith.charAt(i)));
			
			new Thread(crawler).start();
		}
		
	}

}
